#include <bits/stdc++.h>
using namespace std;
long long n,o,a,b,ab,jediniceKrviPacijenta[10020],resenje[10020][4];
bool nemoguce=false;
string krvnaGrupaPacijenta[10020];
int main(){
cin >> n >> o >> a >> b >> ab;
for(int i=1; i<=n; i++){
    cin >> krvnaGrupaPacijenta[i] >> jediniceKrviPacijenta[i];
}
for(int i=1; i<=n; i++){
    if(krvnaGrupaPacijenta[i]=="O"){
        if(o>=jediniceKrviPacijenta[i]){
            o-=jediniceKrviPacijenta[i];
            resenje[i][1]=jediniceKrviPacijenta[i];
        }
        else{
        nemoguce=true;
        break;
        }
    }
    else if(krvnaGrupaPacijenta[i]=="A"){
        if(a>=jediniceKrviPacijenta[i]){
            a-=jediniceKrviPacijenta[i];
            resenje[i][2]=jediniceKrviPacijenta[i];
        }
        else if(a+o>=jediniceKrviPacijenta[i]){
            resenje[i][2]=a;
            resenje[i][1]=jediniceKrviPacijenta[i]-a;
            o-=jediniceKrviPacijenta[i]-a;
            a=0;
        }
        else{
        nemoguce=true;
        break;
        }
    }
    else if(krvnaGrupaPacijenta[i]=="B"){
        if(b>=jediniceKrviPacijenta[i]){
            b-=jediniceKrviPacijenta[i];
            resenje[i][3]=jediniceKrviPacijenta[i];
        }
        else if(b+o>=jediniceKrviPacijenta[i]){
            resenje[i][1]=jediniceKrviPacijenta[i]-b;
            resenje[i][3]=b;
            o-=jediniceKrviPacijenta[i]-b;
            b=0;
        }
        else{
            nemoguce=true;
            break;
        }
    }
    else{
    nemoguce=true;
    break;
    }
}
if(nemoguce==false){
cout << "moguce" << endl;
for(int i=1; i<=n; i++){
    printf("%i %i %i %i",resenje[i][1],resenje[i][2],resenje[i][3],resenje[i][4]);
    cout << endl;
}
}
else cout << "nemoguce" << endl;

return 0;
}